//
//  GameViewController.m
//  RoxigaEngine
//
//  Created by 大西 武 on 2017/06/27.
//  Copyright © 2017年 大西 武. All rights reserved.
//

#import "GameViewController.h"
#import "RoxigaMain.h"

@implementation GameViewController
{
    MTKView *_view;

    RoxigaMain *_renderer;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    _view = (MTKView *)self.view;

    _view.device = MTLCreateSystemDefaultDevice();

    if(!_view.device)
    {
        NSLog(@"Metal is not supported on this device");
        self.view = [[UIView alloc] initWithFrame:self.view.frame];
        return;
    }

    _renderer = [[RoxigaMain alloc] initWithMetalKitView:_view];

    [_renderer mtkView:_view drawableSizeWillChange:_view.bounds.size];

    _view.delegate = _renderer;
}

-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
{
	[_renderer touchesBegan:touches
				  withEvent:event
					   view:(MTKView *)self.view];
}

-(void)touchesMoved:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
{
	[_renderer touchesMoved:touches
				  withEvent:event
					   view:(MTKView *)self.view];
}

-(void)touchesEnded:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
{
	[_renderer touchesEnded:touches
				  withEvent:event
					   view:(MTKView *)self.view];
}

@end
