//
//  RoxigaMain.m
//  RoxigaEngine
//
//  Created by 大西 武 on 2017/06/28.
//  Copyright © 2017年 大西 武. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "RoxigaMain.h"
#import "RoxigaModel.h"
#import "Hikaru.h"
#import "AAPLTransforms.h"
#import <vector>

@implementation RoxigaMain
{
@private
	bool _touch;
	RoxigaModel* _model;
}

-(nonnull instancetype)initWithMetalKitView:(nonnull MTKView *)view;
{
	self = [super initWithMetalKitView:view];
	_bgColor = MTLClearColorMake(1.0, 0.8, 0.8, 1.0);

	_touch = false;
	_model = [super loadModel:[Hikaru alloc]];
	
	return self;
}

- (void)drawInMTKView:(nonnull MTKView *)view
{
	_eye    = {0.0, 200.0, -500.0};
	_center = {0, 100, 0};
	_up     = {0.0, 1.0, 0.0};
	
	if (_touch)
	{
		float radians = AAPL::Math::radians(_model->_rotation.y);
		_model->_translation.x += sinf(radians)*2;
		_model->_translation.z -= cosf(radians)*2;
	}
	else
	{
		_model->_rotation.y += 2;
		if (_model->_rotation.y >= 360)
		{
			_model->_rotation.y -= 360;
		}
	}
	
	[super drawInMTKView:view];
}

-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event view:(MTKView *)view
{
	_touch = true;
	[_model playAnimation:1 loop:true];
}

-(void)touchesMoved:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event view:(MTKView *)view
{
}

-(void)touchesEnded:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event view:(MTKView *)view
{
	_touch = false;
	[_model playAnimation:0 loop:true];
}

@end

